## camlp4 2.04

=== Makefile ===
# $Id: Makefile,v 2.4 1999/11/20 03:50:25 ddr Exp $

include config/Makefile

DIRS=tools odyl camlp4 meta etc top ocpp lib man
FDIRS=odyl camlp4 meta lib
SHELL=/bin/sh

all:
	set -e; for i in $(DIRS); do cd $$i; $(MAKE) all; cd ..; done

opt:
	cd lib; $(MAKE) opt

clean_hot:
	for i in $(DIRS); do (cd $$i; $(MAKE) clean); done

depend:
	for i in $(DIRS); do (cd $$i; $(MAKE) depend); done

install:
	for i in $(DIRS); do (cd $$i; $(MAKE) install BINDIR=$(BINDIR) LIBDIR=$(LIBDIR) MANDIR=$(MANDIR)); done

scratch:
	$(MAKE) clean
	rm -f boot/*.cm[oi] boot/camlp4*
	rm -rf boot/SAVED

clean: clean_hot clean_cold

# Normal bootstrap

bootstrap: backup promote clean_hot all compare

backup:
	mkdir boot.new
	make mv_cvs FROM=boot TO=boot.new
	mv boot boot.new/SAVED
	mv boot.new boot

restore:
	mv boot/SAVED boot.new
	make mv_cvs FROM=boot TO=boot.new
	rm -rf boot
	mv boot.new boot

promote:
	for i in $(FDIRS); do (cd $$i; $(MAKE) promote); done

compare:
	@if (for i in $(FDIRS); do \
		if (cd $$i; $(MAKE) compare 2>/dev/null); then :; \
		else exit 1; fi; \
	     done); \
	then echo "Fixpoint reached, bootstrap succeeded."; \
	else echo "Fixpoint not reached, try one more bootstrapping cycle."; \
	fi

cleanboot:
	rm -rf boot/SAVED/SAVED


# Fast bootstrap

bootstrap_fast: backup promote clean_hot fast compare

fast:
	set -e; for i in tools $(FDIRS); do cd $$i; $(MAKE) all; cd ..; done

clean_fast:
	for i in $(FDIRS); do (cd $$i; $(MAKE) clean); done


# The very beginning

world:
	$(MAKE) clean_cold library_cold compile_cold
	$(MAKE) promote_cold
	$(MAKE) clean_cold clean_hot compile_tool library all

compile_tool:
	cd tools; $(MAKE) all

library:
	cd lib; $(MAKE) all promote

# Cold start using pure Objective Caml sources

library_cold:
	cd ocaml_src/lib; $(MAKE) all promote

compile_cold:
	cd ocaml_src; set -e; \
	for i in $(FDIRS); do cd $$i; $(MAKE) all; cd ..; done

promote_cold:
	for i in $(FDIRS); do \
		(cd ocaml_src/$$i; $(MAKE) promote); \
	done

clean_cold:
	for i in $(FDIRS); do \
		(cd ocaml_src/$$i; $(MAKE) clean); \
	done

# Stealing some Ocaml compiler sources

steal:
	@if test "$(OCAML_SRC)" = ""; then \
		echo "usage: make steal OCAML_SRC=..."; exit 1; \
	fi
	for i in $(FDIRS); do (cd $$i; $(MAKE) steal); done
	for i in $(FDIRS); do (cd ocaml_src/$$i; $(MAKE) steal); done

compare_stolen:
	@if test "$(OCAML_SRC)" = ""; then \
		echo "usage: make compare_stolen OCAML_SRC=..."; exit 1; \
	fi
	for i in $(FDIRS); do (cd $$i; $(MAKE) compare_stolen); done

# Bootstrap the sources

bootstrap_sources:
	cd etc; make pr_o.cmo
	mkdir ocaml_src.new
	@-for i in $(FDIRS); do \
		(mkdir ocaml_src.new/$$i; cd ocaml_src.new/$$i; \
		 sed 's/# $$Id.*\$$/# Id/' ../../$$i/Makefile | \
		 sed 's-include ../config-include ../../config-g' | \
		 sed 's-../boot-../../boot-g' > Makefile; \
		 cp ../../$$i/.depend .) \
	 done
	@-for i in $(FDIRS); do \
		for j in $$i/*.ml*; do \
			echo ============================================; \
			echo ocaml_src.new/$$j; \
			./tools/conv.sh $$j | \
			sed 's/$$Id.*\$$/Id/' > ocaml_src.new/$$j; \
		done; \
	done

promote_sources:
	make mv_cvs FROM=ocaml_src TO=ocaml_src.new
	for i in $(FDIRS); do \
		make mv_cvs FROM=ocaml_src/$$i TO=ocaml_src.new/$$i; \
	done
	mv ocaml_src/tools ocaml_src.new/.
	mv ocaml_src ocaml_src.new/SAVED
	mv ocaml_src.new ocaml_src

unpromote_sources:
	mv ocaml_src ocaml_src.new
	mv ocaml_src.new/SAVED ocaml_src
	mv ocaml_src.new/tools ocaml_src/.
	for i in $(FDIRS); do \
		make mv_cvs FROM=ocaml_src.new/$$i TO=ocaml_src/$$i; \
	done
	make mv_cvs FROM=ocaml_src.new TO=ocaml_src

clean_sources:
	rm -rf ocaml_src/SAVED/SAVED

# Utility

mv_cvs:
	test ! -d $(FROM)/CVS || mv $(FROM)/CVS $(TO)/.
	test ! -f $(FROM)/.cvsignore || mv $(FROM)/.cvsignore $(TO)/.

=== camlp4/Makefile ===
# $Id: Makefile,v 2.9 1999/11/23 21:04:59 ddr Exp $

include ../config/Makefile

SHELL=/bin/sh

INCLUDES=-I ../odyl -I ../boot
OCAMLCFLAGS=$(INCLUDES)
LINKFLAGS=$(INCLUDES)
INTERFACES=-I $(OLIBDIR) Arg Array Buffer Callback Char Digest Filename Format Gc Genlex Hashtbl Lazy Lexing List Map Marshal Obj Oo Parsing Pervasives Printexc Printf Queue Random Set Sort Stack Stream String Sys Weak -I ../boot Gramext Grammar Plexer Stdpp Token -I . Ast2pt Asttypes Oconfig Location Longident MLast Parsetree Pcaml Pretty Quotation Warnings
CAMLP4_INTF=ast2pt.cmi asttypes.cmi oconfig.cmi warnings.cmi location.cmi longident.cmi mLast.cmi parsetree.cmi pcaml.cmi pretty.cmi quotation.cmi
CAMLP4_OBJS=../boot/stdpp.cmo ../boot/token.cmo ../boot/plexer.cmo ../boot/gramext.cmo ../boot/grammar.cmo oconfig.cmo quotation.cmo ast2pt.cmo pretty.cmo reloc.cmo pcaml.cmo argl.cmo crc.cmo
CAMLP4_XOBJS=../lib/stdpp.cmx ../lib/token.cmx ../lib/plexer.cmx ../lib/gramext.cmx ../lib/grammar.cmx oconfig.cmx quotation.cmx ast2pt.cmx pretty.cmx reloc.cmx pcaml.cmx argl.cmx
OBJS=../odyl/odyl.cma camlp4.cma
XOBJS=camlp4.cmxa
CAMLP4M=

CAMLP4=camlp4$(EXE)
CAMLP4OPT=phony

all: $(CAMLP4)
opt: $(CAMLP4OPT)

$(CAMLP4): $(OBJS) ../odyl/odyl.cmo
	$(OCAMLC) $(OBJS) $(CAMLP4M) ../odyl/odyl.cmo -linkall -o $(CAMLP4)

$(CAMLP4OPT): $(XOBJS) ../odyl/odyl.cmx
	$(OCAMLOPT) $(XOBJS) $(CAMLP4M) ../odyl/odyl.cmx -linkall -o $(CAMLP4OPT)

camlp4.cma: $(CAMLP4_OBJS)
	$(OCAMLC) $(LINKFLAGS) $(CAMLP4_OBJS) -a -o camlp4.cma

camlp4.cmxa: $(CAMLP4_XOBJS)
	$(OCAMLOPT) $(LINKFLAGS) $(CAMLP4_XOBJS) -a -o camlp4.cmxa

crc.cmo: ./extract_crc$(EXE) $(CAMLP4_INTF)
	./extract_crc $(INTERFACES) > crc.ml
	echo "let _ = Dynlink.add_available_units crc_unit_list" >> crc.ml
	$(OCAMLC) $(OCAMLCFLAGS) -c crc.ml

./extract_crc$(EXE): extract_crc.cmo
	$(OCAMLC) dynlink.cma extract_crc.cmo -o ./extract_crc$(EXE)

steal:
	$(MAKE) copy_steal DIR=parsing FILE=asttypes.mli
	$(MAKE) copy_steal DIR=parsing FILE=location.mli
	$(MAKE) copy_steal DIR=parsing FILE=longident.mli
	$(MAKE) copy_steal DIR=parsing FILE=parsetree.mli
	$(MAKE) copy_steal DIR=utils FILE=warnings.mli
	grep ast $(OCAML_SRC)/utils/config.mli > oconfig.mli
	grep ast $(OCAML_SRC)/utils/config.ml | sed "s/^and/let/" > oconfig.ml
	$(MAKE) copy_steal DIR=otherlibs/dynlink FILE=extract_crc.ml
	sed "s/let load_path = ref \[.*\]/let load_path = ref []/" extract_crc.ml | sed 's/$$Id.*\$$/Id/' > t
	mv t extract_crc.ml

copy_steal:
	sed 's/\$$Id.*\$$/Id/' $(OCAML_SRC)/$(DIR)/$(FILE) > $(FILE)

compare_stolen:
	@echo =================================================
	@echo asttypes.mli
	diff asttypes.mli $(OCAML_SRC)/parsing/asttypes.mli; exit 0
	@echo =================================================
	@echo location.mli
	diff location.mli $(OCAML_SRC)/parsing/location.mli; exit 0
	@echo =================================================
	@echo longident.mli
	diff longident.mli $(OCAML_SRC)/parsing/longident.mli; exit 0
	@echo =================================================
	@echo parsetree.mli
	diff parsetree.mli $(OCAML_SRC)/parsing/parsetree.mli; exit 0
	@echo =================================================
	@echo warnings.mli
	diff warnings.mli $(OCAML_SRC)/utils/warnings.mli; exit 0
	@echo =================================================
	@echo config.mli
	diff config.mli $(OCAML_SRC)/utils/config.mli; exit 0
	@echo =================================================
	@echo config.ml
	cat $(OCAML_SRC)/utils/config.ml | diff config.ml -; exit 0
	@echo =================================================
	@echo extract_crc.ml
	sed "s/let load_path = ref \[.*\]/let load_path = ref []/" $(OCAML_SRC)/otherlibs/dynlink/extract_crc.ml | diff extract_crc.ml -; exit 0

clean::
	rm -f *.cm* *.pp[io] *.o *.bak .*.bak *.out *.opt
	rm -f $(CAMLP4) crc.ml extract_crc$(EXE)

depend:
	cp .depend .depend.bak
	> .depend
	@for i in *.mli *.ml; do \
	  ../tools/apply pr_depend.cmo -- $(INCLUDES) $$i >> .depend; \
	done

promote:
	cp $(CAMLP4) ../boot/.

compare:
	@for j in $(CAMLP4); do \
		if cmp $$j ../boot/$$j; then :; else exit 1; fi; \
	done

install:
	-$(MKDIR) $(BINDIR)
	cp $(CAMLP4) $(BINDIR)/.
	cp mLast.mli quotation.mli pcaml.mli $(LIBDIR)/.
	cp mLast.cmi quotation.cmi ast2pt.cmi pcaml.cmi $(LIBDIR)/.
	cp extract_crc$(EXE) camlp4.cma $(LIBDIR)/.

include .depend

=== etc/Makefile ===
# $Id: Makefile,v 2.4 1999/09/06 10:43:13 ddr Exp $

include ../config/Makefile

INCLUDES=-I ../camlp4 -I ../boot
OCAMLCFLAGS=$(INCLUDES)
OBJS=q_phony.cmo pa_o.cmo pa_op.cmo pa_oop.cmo pa_ru.cmo pa_format.cmo pa_ifdef.cmo pr_r.cmo pr_rp.cmo pr_o.cmo pr_op.cmo pr_extend.cmo pr_null.cmo pr_depend.cmo pa_sml.cmo
INTF=pa_ifdef.cmi pa_o.cmi
CAMLP4OM=pa_o.cmo pa_op.cmo ../meta/pr_dump.cmo
CAMLP4OMX=pa_o.cmx pa_op.cmx ../meta/pr_dump.cmx ../meta/pa_extend.cmx ../meta/q_MLast.cmx
SHELL=/bin/sh
OUT=$(OBJS) camlp4o$(EXE)
OPT=camlp4o.opt

all: $(OUT) mkcamlp4.sh
opt: $(OPT)

camlp4o$(EXE): ../camlp4/camlp4$(EXE) $(CAMLP4OM)
	rm -f camlp4o$(EXE)
	cd ../camlp4; $(MAKE) CAMLP4=../etc/camlp4o$(EXE) CAMLP4M="-I ../etc $(CAMLP4OM)"

camlp4o.opt: $(CAMLP4OMX)
	rm -f camlp4o.opt
	cd ../camlp4; $(MAKE) opt CAMLP4OPT=../etc/camlp4o.opt CAMLP4M="-I ../etc $(CAMLP4OMX)"

mkcamlp4.sh: mkcamlp4.sh.tpl
	sed -e "s'OLIBDIR'$(OLIBDIR)'g" -e "s'LIBDIR'$(LIBDIR)'g" mkcamlp4.sh.tpl > mkcamlp4.sh

clean::
	rm -f *.cm[ioa] *.pp[io] *.o *.bak .*.bak *.out *.opt
	rm -f mkcamlp4.sh camlp4o$(EXE)

depend:
	cp .depend .depend.bak
	> .depend
	@for i in *.mli *.ml; do \
	  ../tools/apply pr_depend.cmo -- $(INCLUDES) $$i >> .depend; \
	done

get_promote:

install:
	-$(MKDIR) $(LIBDIR) $(BINDIR)
	cp $(OBJS) $(LIBDIR)/.
	cp $(INTF) $(LIBDIR)/.
	cp lib.sml $(LIBDIR)/.
	cp camlp4o$(EXE) $(BINDIR)/.
	cp mkcamlp4.sh $(BINDIR)/mkcamlp4
	chmod a+x $(BINDIR)/mkcamlp4

include .depend

=== lablp4/Makefile ===
# $Id: Makefile,v 1.3 1999/03/04 16:37:25 ddr Exp $

include ../config/Makefile

SHELL=/bin/sh

INCLUDES=-I ../camlp4 -I ../boot
OCAMLCFLAGS=$(INCLUDES)
LABL_OBJS=llexer.cmo pa_lo.cmo pa_lablext.cmo
DUMP_OBJS=lasttypes.cmo lparsetree.cmo lconfig.cmo ast2lpt.cmo pr_ldump.cmo
LABLP4M=pa_labl.cma pr_ldump.cma

all: $(LABLP4M)

pa_labl.cma: $(LABL_OBJS)
	$(OCAMLC) $(LINKFLAGS) $(LABL_OBJS) -a -o pa_labl.cma

pr_ldump.cma: $(DUMP_OBJS)
	$(OCAMLC) $(LINKFLAGS) $(DUMP_OBJS) -a -o pr_ldump.cma

install:
	cp $(LABLP4M) $(LIBDIR)/.

clean::
	rm -f *.cm* *.pp[io] *.o *.bak .*.bak *.out *.opt
	rm -f $(LABLP4M)

depend:
	cp .depend .depend.bak
	> .depend
	@for i in *.mli *.ml; do \
	  ../tools/apply pr_depend.cmo -- $(INCLUDES) $$i >> .depend; \
	done

include .depend

=== lib/Makefile ===
# $Id: Makefile,v 2.4 1999/09/06 10:43:15 ddr Exp $

include ../config/Makefile

INCLUDES=
OCAMLCFLAGS=$(INCLUDES)
OBJS=stdpp.cmo token.cmo plexer.cmo gramext.cmo grammar.cmo
SHELL=/bin/sh
TARGET=gramlib.cma

all: $(TARGET)
opt: $(TARGET:.cma=.cmxa)

$(TARGET): $(OBJS)
	$(OCAMLC) $(OBJS) -a -o $(TARGET)

$(TARGET:.cma=.cmxa): $(OBJS:.cmo=.cmx)
	$(OCAMLOPT) $(OBJS:.cmo=.cmx) -a -o $(TARGET:.cma=.cmxa)

steal::

compare_stolen::

clean::
	rm -f *.cm[ioax] *.cmxa *.pp[io] *.o *.a *.bak .*.bak $(TARGET)

depend:
	cp .depend .depend.bak
	> .depend
	@for i in *.mli *.ml; do \
	  ../tools/apply pr_depend.cmo -- $(INCLUDES) $$i >> .depend; \
	done

promote:
	cp $(OBJS) $(OBJS:.cmo=.cmi) ../boot/.

compare:
	@for j in $(OBJS) $(OBJS:.cmo=.cmi); do \
		if cmp $$j ../boot/$$j; then :; else exit 1; fi; \
	done

install:
	-$(MKDIR) $(LIBDIR)
	cp $(TARGET) *.mli $(LIBDIR)/.
	cp *.cmi $(LIBDIR)/.
	if test -f $(TARGET:.cma=.cmxa); then $(MAKE) installopt LIBDIR=$(LIBDIR); fi

installopt:
	cp $(TARGET:.cma=.cmxa) *.cmx $(LIBDIR)/.
	if test -f $(TARGET:.cma=.lib); then \
		cp $(TARGET:.cma=.lib) $(LIBDIR)/.; \
	else \
		tar cf - $(TARGET:.cma=.a) | (cd $(LIBDIR)/.; tar xf -); \
	fi

include .depend

=== man/Makefile ===
# $Id: Makefile,v 2.1 1999/05/14 11:03:32 ddr Exp $

include ../config/Makefile

TARGET=camlp4.1

all: $(TARGET)

clean::
	rm -f $(TARGET)

depend:

get_promote:

install:
	-$(MKDIR) $(MANDIR)
	cp $(TARGET) $(MANDIR)/.
	cd $(MANDIR); ln -sf $(TARGET) camlp4o.1
	cd $(MANDIR); ln -sf $(TARGET) camlp4r.1
	cd $(MANDIR); ln -sf $(TARGET) mkcamlp4.1
	cd $(MANDIR); ln -sf $(TARGET) ocpp.1

camlp4.1: camlp4.1.tpl
	sed -e "s'LIBDIR'$(LIBDIR)'g" camlp4.1.tpl > camlp4.1

=== meta/Makefile ===
# $Id: Makefile,v 2.5 1999/09/06 10:43:16 ddr Exp $

include ../config/Makefile

INCLUDES=-I ../camlp4 -I ../boot
OCAMLCFLAGS=$(INCLUDES)
OBJS=q_MLast.cmo pa_r.cmo pa_rp.cmo pa_extend.cmo pa_extend_m.cmo pr_dump.cmo
CAMLP4RM=pa_r.cmo pa_rp.cmo pr_dump.cmo
CAMLP4RMX=pa_r.cmx pa_rp.cmx pr_dump.cmx pa_extend.cmx q_MLast.cmx
SHELL=/bin/sh
OUT=$(OBJS) camlp4r$(EXE)
OPT=camlp4r.opt

all: $(OUT)
opt: $(OPT)

camlp4r$(EXE): ../camlp4/camlp4$(EXE) $(CAMLP4RM)
	rm -f camlp4r$(EXE)
	cd ../camlp4; $(MAKE) CAMLP4=../meta/camlp4r$(EXE) CAMLP4M="-I ../meta $(CAMLP4RM)"

camlp4r.opt: $(CAMLP4RMX)
	rm -f camlp4r.opt
	cd ../camlp4; $(MAKE) opt CAMLP4OPT=../meta/camlp4r.opt CAMLP4M="-I ../meta $(CAMLP4RMX)"

steal:

compare_stolen:

clean::
	rm -f *.cm[ioa] *.pp[io] *.o *.bak .*.bak $(OUT) $(OPT)

depend:
	cp .depend .depend.bak
	> .depend
	@for i in *.mli *.ml; do \
	  ../tools/apply pr_depend.cmo -- $(INCLUDES) $$i >> .depend; \
	done

promote:
	cp $(OUT) ../boot/.

compare:
	@for j in $(OUT); do \
		if cmp $$j ../boot/$$j; then :; else exit 1; fi; \
	done

install:
	-$(MKDIR) $(LIBDIR) $(BINDIR)
	cp $(OBJS) $(LIBDIR)/.
	cp camlp4r$(EXE) $(BINDIR)/.

include .depend

=== ocpp/Makefile ===
# $Id: Makefile,v 2.3 1999/03/04 16:35:13 ddr Exp $

include ../config/Makefile

SHELL=/bin/sh

INCLUDES=-I ../camlp4 -I ../boot -I ../odyl
OCAMLCFLAGS=$(INCLUDES)
LINKFLAGS=$(INCLUDES)
OBJS=crc.cmo ocpp.cmo
INTERFACES=-I $(OLIBDIR) Arg Array Callback Char Digest Filename Format Gc Genlex Hashtbl Lexing List Map Obj Oo Parsing Pervasives Printexc Printf Queue Random Set Sort Stack Stream String Sys Weak -I ../boot Gramext Grammar Plexer Stdpp Token -I ../camlp4 MLast Quotation

all: ocpp$(EXE)

ocpp$(EXE): $(OBJS)
	$(OCAMLC) $(LINKFLAGS) ../boot/stdpp.cmo ../camlp4/quotation.cmo ../odyl/odyl.cma $(OBJS) ../odyl/odyl.cmo -linkall -o ocpp$(EXE)

crc.cmo:
	../camlp4/extract_crc $(INTERFACES) > crc.ml
	echo "let _ = Dynlink.add_available_units crc_unit_list" >> crc.ml
	$(OCAMLC) $(OCAMLCFLAGS) -c crc.ml

clean::
	rm -f *.cm[ioa] *.pp[io] *.o *.out *.bak .*.bak crc.ml ocpp$(EXE)

install:
	-$(MKDIR) $(LIBDIR) $(BINDIR)
	cp $(OBJS) $(LIBDIR)
	cp ocpp$(EXE) $(BINDIR)/.

depend:

include .depend

=== odyl/Makefile ===
# $Id: Makefile,v 2.5 1999/09/06 10:43:24 ddr Exp $

include ../config/Makefile

SHELL=/bin/sh

INCLUDES=
OCAMLCFLAGS=$(INCLUDES)
LINKFLAGS=$(INCLUDES)

OBJS=odyl_config.cmo odyl_main.cmo

all: odyl$(EXE)

odyl$(EXE): odyl.cma odyl.cmo
	$(OCAMLC) odyl.cma odyl.cmo -o odyl$(EXE)

odyl.cma: $(OBJS)
	$(OCAMLC) $(LINKFLAGS) dynlink.cma $(OBJS) -a -o odyl.cma

odyl_config.cmo:
	echo "let standard_library =" > odyl_config.ml
	echo "  try Sys.getenv \"CAMLP4LIB\" with" >> odyl_config.ml
	echo "    Not_found -> \"$(LIBDIR)\"" >> odyl_config.ml
	$(OCAMLC) $(OCAMLCFLAGS) -c odyl_config.ml

steal:

compare_stolen:

clean::
	rm -f *.cm[ioa] *.pp[io] *.o *.bak .*.bak *.out *.opt
	rm -f odyl_config.ml odyl$(EXE)

depend:
	cp .depend .depend.bak
	> .depend
	@for i in *.mli *.ml; do \
	  ../tools/apply pr_depend.cmo -- $(INCLUDES) $$i >> .depend; \
	done

promote:

compare:

install:
	-$(MKDIR) $(LIBDIR) $(BINDIR)
	cp odyl.cmo odyl.cma $(LIBDIR)
	cp odyl$(EXE) $(BINDIR)/.

include .depend

=== tools/Makefile ===
# $Id: Makefile,v 2.1 1999/03/03 23:49:34 ddr Exp $

include ../config/Makefile

all: compile$(EXE) apply$(EXE)

compile$(EXE): compile.ml
	../boot/camlp4r -nolib -I ../boot -o compile.ppo -impl compile.ml
	$(OCAMLC) $(OCAMLCFLAGS) -impl compile.ppo -o compile$(EXE)
	rm -f compile.ppo

apply$(EXE): apply.ml
	../boot/camlp4r -nolib -I ../boot -o apply.ppo -impl apply.ml
	$(OCAMLC) $(OCAMLCFLAGS) -impl apply.ppo -o apply$(EXE)
	rm -f apply.ppo

clean::
	rm -f *.cm[ioa] *.pp[io] *.o *.bak .*.bak compile$(EXE) apply$(EXE)

depend:

install:

=== top/Makefile ===
# $Id: Makefile,v 2.3 1999/03/04 16:35:14 ddr Exp $

include ../config/Makefile

INCLUDES=-I ../camlp4 -I ../boot
OCAMLCFLAGS=$(INCLUDES)

CAMLP4_OBJS=../boot/stdpp.cmo ../boot/token.cmo ../boot/plexer.cmo ../boot/gramext.cmo ../boot/grammar.cmo ../camlp4/quotation.cmo ../camlp4/ast2pt.cmo ../camlp4/reloc.cmo ../camlp4/pcaml.cmo
TOP=camlp4_top.cmo
ROBJS=$(CAMLP4_OBJS) ../meta/pa_r.cmo ../meta/pa_rp.cmo $(TOP)
OOBJS=$(CAMLP4_OBJS) ../etc/pa_o.cmo ../etc/pa_op.cmo $(TOP)
OOOBJS=$(CAMLP4_OBJS) ../etc/pa_o.cmo ../etc/pa_oop.cmo $(TOP)
OBJS=../camlp4/quotation.cmo ../camlp4/reloc.cmo ../camlp4/ast2pt.cmo ../camlp4/pcaml.cmo camlp4_top.cmo

TARGET=camlp4o.cma camlp4r.cma camlp4_top.cma

all: $(TARGET)

camlp4oo.cma: $(OOOBJS)
	$(OCAMLC) $(OOOBJS) -linkall -a -o camlp4oo.cma

camlp4o.cma: $(OOBJS)
	$(OCAMLC) $(OOBJS) -linkall -a -o camlp4o.cma

camlp4r.cma: $(ROBJS)
	$(OCAMLC) $(ROBJS) -linkall -a -o camlp4r.cma

camlp4_top.cma: $(OBJS)
	$(OCAMLC) $(OBJS) -a -o camlp4_top.cma

clean::
	rm -f *.cm[ioa] *.pp[io] *.o *.bak .*.bak $(TARGET)

depend:
	cp .depend .depend.bak
	> .depend
	@for i in *.mli *.ml; do \
	  ../tools/apply pr_depend.cmo -- $(INCLUDES) $$i >> .depend; \
	done

get_promote:

install:
	-$(MKDIR) $(LIBDIR)
	cp $(TARGET) $(LIBDIR)/.

include .depend

=== ocaml_src/camlp4/Makefile ===
# Id

include ../../config/Makefile

SHELL=/bin/sh

INCLUDES=-I ../odyl -I ../../boot
OCAMLCFLAGS=$(INCLUDES)
LINKFLAGS=$(INCLUDES)
INTERFACES=-I $(OLIBDIR) Arg Array Buffer Callback Char Digest Filename Format Gc Genlex Hashtbl Lazy Lexing List Map Marshal Obj Oo Parsing Pervasives Printexc Printf Queue Random Set Sort Stack Stream String Sys Weak -I ../../boot Gramext Grammar Plexer Stdpp Token -I . Ast2pt Asttypes Oconfig Location Longident MLast Parsetree Pcaml Pretty Quotation Warnings
CAMLP4_INTF=ast2pt.cmi asttypes.cmi oconfig.cmi warnings.cmi location.cmi longident.cmi mLast.cmi parsetree.cmi pcaml.cmi pretty.cmi quotation.cmi
CAMLP4_OBJS=../../boot/stdpp.cmo ../../boot/token.cmo ../../boot/plexer.cmo ../../boot/gramext.cmo ../../boot/grammar.cmo oconfig.cmo quotation.cmo ast2pt.cmo pretty.cmo reloc.cmo pcaml.cmo argl.cmo crc.cmo
CAMLP4_XOBJS=../lib/stdpp.cmx ../lib/token.cmx ../lib/plexer.cmx ../lib/gramext.cmx ../lib/grammar.cmx oconfig.cmx quotation.cmx ast2pt.cmx pretty.cmx reloc.cmx pcaml.cmx argl.cmx
OBJS=../odyl/odyl.cma camlp4.cma
XOBJS=camlp4.cmxa
CAMLP4M=

CAMLP4=camlp4$(EXE)
CAMLP4OPT=phony

all: $(CAMLP4)
opt: $(CAMLP4OPT)

$(CAMLP4): $(OBJS) ../odyl/odyl.cmo
	$(OCAMLC) $(OBJS) $(CAMLP4M) ../odyl/odyl.cmo -linkall -o $(CAMLP4)

$(CAMLP4OPT): $(XOBJS) ../odyl/odyl.cmx
	$(OCAMLOPT) $(XOBJS) $(CAMLP4M) ../odyl/odyl.cmx -linkall -o $(CAMLP4OPT)

camlp4.cma: $(CAMLP4_OBJS)
	$(OCAMLC) $(LINKFLAGS) $(CAMLP4_OBJS) -a -o camlp4.cma

camlp4.cmxa: $(CAMLP4_XOBJS)
	$(OCAMLOPT) $(LINKFLAGS) $(CAMLP4_XOBJS) -a -o camlp4.cmxa

crc.cmo: ./extract_crc$(EXE) $(CAMLP4_INTF)
	./extract_crc $(INTERFACES) > crc.ml
	echo "let _ = Dynlink.add_available_units crc_unit_list" >> crc.ml
	$(OCAMLC) $(OCAMLCFLAGS) -c crc.ml

./extract_crc$(EXE): extract_crc.cmo
	$(OCAMLC) dynlink.cma extract_crc.cmo -o ./extract_crc$(EXE)

steal:
	$(MAKE) copy_steal DIR=parsing FILE=asttypes.mli
	$(MAKE) copy_steal DIR=parsing FILE=location.mli
	$(MAKE) copy_steal DIR=parsing FILE=longident.mli
	$(MAKE) copy_steal DIR=parsing FILE=parsetree.mli
	$(MAKE) copy_steal DIR=utils FILE=warnings.mli
	grep ast $(OCAML_SRC)/utils/config.mli > oconfig.mli
	grep ast $(OCAML_SRC)/utils/config.ml | sed "s/^and/let/" > oconfig.ml
	$(MAKE) copy_steal DIR=otherlibs/dynlink FILE=extract_crc.ml
	sed "s/let load_path = ref \[.*\]/let load_path = ref []/" extract_crc.ml | sed 's/$$Id.*\$$/Id/' > t
	mv t extract_crc.ml

copy_steal:
	sed 's/\$$Id.*\$$/Id/' $(OCAML_SRC)/$(DIR)/$(FILE) > $(FILE)

compare_stolen:
	@echo =================================================
	@echo asttypes.mli
	diff asttypes.mli $(OCAML_SRC)/parsing/asttypes.mli; exit 0
	@echo =================================================
	@echo location.mli
	diff location.mli $(OCAML_SRC)/parsing/location.mli; exit 0
	@echo =================================================
	@echo longident.mli
	diff longident.mli $(OCAML_SRC)/parsing/longident.mli; exit 0
	@echo =================================================
	@echo parsetree.mli
	diff parsetree.mli $(OCAML_SRC)/parsing/parsetree.mli; exit 0
	@echo =================================================
	@echo warnings.mli
	diff warnings.mli $(OCAML_SRC)/utils/warnings.mli; exit 0
	@echo =================================================
	@echo config.mli
	diff config.mli $(OCAML_SRC)/utils/config.mli; exit 0
	@echo =================================================
	@echo config.ml
	cat $(OCAML_SRC)/utils/config.ml | diff config.ml -; exit 0
	@echo =================================================
	@echo extract_crc.ml
	sed "s/let load_path = ref \[.*\]/let load_path = ref []/" $(OCAML_SRC)/otherlibs/dynlink/extract_crc.ml | diff extract_crc.ml -; exit 0

clean::
	rm -f *.cm* *.pp[io] *.o *.bak .*.bak *.out *.opt
	rm -f $(CAMLP4) crc.ml extract_crc$(EXE)

depend:
	cp .depend .depend.bak
	> .depend
	@for i in *.mli *.ml; do \
	  ../tools/apply pr_depend.cmo -- $(INCLUDES) $$i >> .depend; \
	done

promote:
	cp $(CAMLP4) ../../boot/.

compare:
	@for j in $(CAMLP4); do \
		if cmp $$j ../../boot/$$j; then :; else exit 1; fi; \
	done

install:
	-$(MKDIR) $(BINDIR)
	cp $(CAMLP4) $(BINDIR)/.
	cp mLast.mli quotation.mli pcaml.mli $(LIBDIR)/.
	cp mLast.cmi quotation.cmi ast2pt.cmi pcaml.cmi $(LIBDIR)/.
	cp extract_crc$(EXE) camlp4.cma $(LIBDIR)/.

include .depend

## camlp4 4.02.1+3

=== Makefile ===
OB := ocamlbuild -classic-display -no-ocamlfind
DESTDIR=

-include config.sh

OB += $(OB_FLAGS)

.PHONY: default
default: byte

.PHONY: byte
byte:
	$(OB) `./build/camlp4-byte-only.sh`

.PHONY: native
native:
	$(OB) `./build/camlp4-native-only.sh`

.PHONY: all
all: byte native

.PHONY: install
install:
	env DESTDIR=$(DESTDIR) ./build/install.sh

.PHONY: install-META
install-META: camlp4/META
	mkdir -p $(DESTDIR)${PKGDIR}/camlp4/
	cp -f camlp4/META $(DESTDIR)${PKGDIR}/camlp4/

camlp4/META: camlp4/META.in
	sed -e s/@@VERSION@@/${version}/g $? > $@

.PHONY: bootstrap
bootstrap:
	./build/camlp4-bootstrap.sh

.PHONY: Camlp4Ast
Camlp4Ast:
	./build/camlp4-mkCamlp4Ast.sh

.PHONY: clean
clean:
	rm -rf _build

.PHONY: distclean
distclean:
	rm -rf _build myocamlbuild_config.ml Makefile.config

=== debian/changelog ===
camlp4 (4.02.1+3-2) unstable; urgency=medium

  * Upload to unstable

 -- Stéphane Glondu <glondu@debian.org>  Thu, 08 Oct 2015 12:02:03 +0200

camlp4 (4.02.1+3-1) experimental; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Sun, 01 Mar 2015 06:23:28 +0100

camlp4 (4.02.1+2-1) experimental; urgency=low

  * Initial upload (Closes: #778521).

 -- Stéphane Glondu <glondu@debian.org>  Mon, 16 Feb 2015 11:26:59 +0100

=== debian/control ===
Source: camlp4
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Stéphane Glondu <glondu@debian.org>
Build-Depends:
 debhelper (>= 9),
 ocaml-nox (>= 4.02.1),
 dh-ocaml
Standards-Version: 3.9.6
Homepage: https://github.com/ocaml/camlp4
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/camlp4.git
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/camlp4.git

Package: camlp4
Architecture: any
Depends:
 libcamlp4-ocaml-dev,
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends}
Provides:
 camlp4-extra,
 ${ocaml:Provides}
Recommends: ocaml-findlib
Breaks: camlp4-extra (<< 4.02.1)
Replaces: camlp4-extra (<< 4.02.1)
Description: Pre Processor Pretty Printer for OCaml
 Camlp4 is a software system for writing extensible parsers for
 programming languages. It provides a set of OCaml libraries that are
 used to define grammars as well as loadable syntax extensions of such
 grammars. Camlp4 stands for Caml Preprocessor and Pretty-Printer and
 one of its most important applications is the definition of
 domain-specific extensions of the syntax of OCaml.
 .
 This package contains CamlP4 executables for pre-processing and
 pretty-printing OCaml sources both interactively and in a batch
 fashion.

Package: libcamlp4-ocaml-dev
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends}
Provides:
 ${ocaml:Provides}
Recommends: ocaml-findlib
Breaks: camlp4 (<< 4.02.1)
Replaces: camlp4 (<< 4.02.1)
Description: Pre Processor Pretty Printer for OCaml (libraries)
 Camlp4 is a software system for writing extensible parsers for
 programming languages. It provides a set of OCaml libraries that are
 used to define grammars as well as loadable syntax extensions of such
 grammars. Camlp4 stands for Caml Preprocessor and Pretty-Printer and
 one of its most important applications is the definition of
 domain-specific extensions of the syntax of OCaml.
 .
 This package contains CamlP4 libraries.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DESTDIR=$(CURDIR)/debian/tmp
include /usr/share/ocaml/ocamlvars.mk

ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
TARGET := all
else
TARGET := default
endif

%:
	dh $@ --with ocaml

.PHONY: override_dh_auto_configure
override_dh_auto_configure:
	./configure

.PHONY: override_dh_auto_build
override_dh_auto_build:
	$(MAKE) $(TARGET)

.PHONY: override_dh_auto_install
override_dh_auto_install:
	dh_auto_install
	$(MAKE) install-META DESTDIR=$(DESTDIR)

.PHONY: override_dh_install
override_dh_install:
	dh_install --fail-missing

## camlp4 4.04+1

=== debian/changelog ===
camlp4 (4.04+1-1) experimental; urgency=medium

  * Add myself to Uploaders.
  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Sat, 04 Mar 2017 15:45:52 +0100

camlp4 (4.03+1-2) experimental; urgency=medium

  * Team upload.
  * Fix Breaks: and Build-Depends:

 -- Ximin Luo <infinity0@debian.org>  Thu, 20 Oct 2016 20:43:44 +0200

camlp4 (4.03+1-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Thu, 20 Oct 2016 18:50:02 +0200

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,12 @@
 Priority: optional
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders:
- Stéphane Glondu <glondu@debian.org>
+ Stéphane Glondu <glondu@debian.org>,
+ Ximin Luo <infinity0@debian.org>
 Build-Depends:
  debhelper (>= 9),
- ocaml-nox (>= 4.02.1),
+ ocaml-nox (>= 4.03.0),
+ ocamlbuild (>= 0.10.1),
  dh-ocaml
 Standards-Version: 3.9.6
 Homepage: https://github.com/ocaml/camlp4
@@ -24,8 +26,8 @@
  camlp4-extra,
  ${ocaml:Provides}
 Recommends: ocaml-findlib
-Breaks: camlp4-extra (<< 4.02.1)
-Replaces: camlp4-extra (<< 4.02.1)
+Breaks: camlp4-extra (<< 4.03)
+Replaces: camlp4-extra (<< 4.03)
 Description: Pre Processor Pretty Printer for OCaml
  Camlp4 is a software system for writing extensible parsers for
  programming languages. It provides a set of OCaml libraries that are
@@ -47,8 +49,8 @@
 Provides:
  ${ocaml:Provides}
 Recommends: ocaml-findlib
-Breaks: camlp4 (<< 4.02.1)
-Replaces: camlp4 (<< 4.02.1)
+Breaks: camlp4 (<< 4.03)
+Replaces: camlp4 (<< 4.03)
 Description: Pre Processor Pretty Printer for OCaml (libraries)
  Camlp4 is a software system for writing extensible parsers for
  programming languages. It provides a set of OCaml libraries that are

=== debian/rules ===
--- 
+++ 
@@ -29,3 +29,8 @@
 .PHONY: override_dh_install
 override_dh_install:
 	dh_install --fail-missing
+
+# This is necessary because upstream contains a build/ directory
+.PHONY: build
+build:
+	dh $@ --with ocaml

## camlp4 4.05+1

=== camlp4/unmaintained/Makefile ===
#########################################################################
#                                                                       #
#                                 OCaml                                 #
#                                                                       #
#                                Camlp4                                 #
#                                                                       #
#   Copyright 2004 Institut National de Recherche en Informatique et    #
#   en Automatique.  All rights reserved.  This file is distributed     #
#   under the terms of the GNU Library General Public License, with     #
#   the special exception on linking described in file ../../LICENSE.   #
#                                                                       #
#########################################################################
#
# The unmaintained directory
#

include ../config/Makefile.cnf

DIRS=format lefteval ocamllex olabl scheme sml

include ../config/Makefile.base

=== camlp4/unmaintained/sml/Makefile ===
#########################################################################
#                                                                       #
#                                 OCaml                                 #
#                                                                       #
#                                Camlp4                                 #
#                                                                       #
#   Copyright 2004 Institut National de Recherche en Informatique et    #
#   en Automatique.  All rights reserved.  This file is distributed     #
#   under the terms of the GNU Library General Public License, with     #
#   the special exception on linking described in file ../../../LICENSE.#
#                                                                       #
#########################################################################
#
# Makefile for pa_sml
# M.Mauny
#

include ../../config/Makefile.cnf

OCAMLTOP=../../..

OCAMLC=$(OCAMLTOP)/ocamlc$(EXE) -nostdlib -I $(OCAMLTOP)/stdlib
OCAMLOPT=$(OCAMLTOP)/ocamlopt$(EXE) -nostdlib -I $(OCAMLTOP)/stdlib

P4INCLUDES=-I ../../meta -I ../../etc -I ../../lib -I ../../camlp4
OCAMLINCLUDES=-I ../../meta -I ../../lib  -I ../../camlp4

CAMLP4=camlp4$(EXE) -nolib
OCAMLCFLAGS=-warn-error A $(OCAMLINCLUDES)

SRC=pa_sml.ml
OBJS=$(SRC:.ml=.cmo)
OBJSX=$(SRC:.ml=.cmx)

all: $(OBJS) smllib.cmo

opt: $(OBJSX) smllib.cmx

depend:
	cp .depend .depend.bak
	> .depend
	for file in $(SRC); do \
	  $(CAMLP4) $(P4INCLUDES) `awk 'NR == 1 { ORS=" "; for (i=2; i < NF; i++) print $$i; } ' $$file` pr_depend.cmo $$i | \
	  sed -e 's| \.\./\.\./\.\.| $$(OCAMLTOP)|g' >> .depend; \
	done

clean:
	rm -f *.cm* *.o *.bak .*.bak


.SUFFIXES: .cmx .cmo .cmi .ml .mli .sml

.mli.cmi:
	$(OCAMLC) $(OCAMLCFLAGS) -c $<


.sml.cmo:
	$(OCAMLC) -I ../../../otherlibs/unix -pp "$(CAMLP4) ./pa_sml.cmo ../../meta/pr_dump.cmo -impl" -c -o $*.cmo -impl $<

.sml.cmx:
	$(OCAMLOPT)  -I ../../../otherlibs/unix -pp "$(CAMLP4) ./pa_sml.cmo ../../meta/pr_dump.cmo -impl" -c -o $*.cmx -impl $<

.ml.cmo:
	$(OCAMLC) $(OCAMLCFLAGS) -pp "$(CAMLP4)  $(P4INCLUDES) `awk 'NR == 1 { ORS=" "; for (i=2; i < NF; i++) print $$i; } ' $<`" -c $<

.ml.cmx:
	$(OCAMLOPT) $(OCAMLCFLAGS) -pp "$(CAMLP4)  $(P4INCLUDES) `awk 'NR == 1 { ORS=" "; for (i=2; i < NF; i++) print $$i; } ' $<`" -c $<

include .depend

=== debian/changelog ===
camlp4 (4.05+1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Ximin Luo <infinity0@debian.org>  Sun, 17 Sep 2017 13:41:19 +0200

camlp4 (4.05+1-1) experimental; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Mon, 31 Jul 2017 19:33:17 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  Ximin Luo <infinity0@debian.org>
 Build-Depends:
  debhelper (>= 9),
- ocaml-nox (>= 4.03.0),
+ ocaml-nox (>= 4.05.0~),
  ocamlbuild (>= 0.10.1),
  dh-ocaml
 Standards-Version: 3.9.6

## camlp4 4.05+2

=== debian/changelog ===
camlp4 (4.05+2-1) unstable; urgency=medium

  * New upstream release
  * Update Vcs-*
  * Bump Standards-Version to 4.4.0
  * Bump debhelper compat level to 12

 -- Stéphane Glondu <glondu@debian.org>  Sun, 04 Aug 2019 08:03:07 +0200

=== debian/control ===
--- 
+++ 
@@ -6,14 +6,14 @@
  Stéphane Glondu <glondu@debian.org>,
  Ximin Luo <infinity0@debian.org>
 Build-Depends:
- debhelper (>= 9),
+ debhelper (>= 12),
  ocaml-nox (>= 4.05.0~),
  ocamlbuild (>= 0.10.1),
  dh-ocaml
-Standards-Version: 3.9.6
+Standards-Version: 4.4.0
 Homepage: https://github.com/ocaml/camlp4
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/camlp4.git
-Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/camlp4.git
+Vcs-Browser: https://salsa.debian.org/ocaml-team/camlp4
+Vcs-Git: https://salsa.debian.org/ocaml-team/camlp4.git
 
 Package: camlp4
 Architecture: any

## camlp4 4.08+1

=== debian/changelog ===
camlp4 (4.08+1-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Tue, 05 Nov 2019 09:16:37 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  Ximin Luo <infinity0@debian.org>
 Build-Depends:
  debhelper (>= 12),
- ocaml-nox (>= 4.05.0~),
+ ocaml-nox (>= 4.08),
  ocamlbuild (>= 0.10.1),
  dh-ocaml
 Standards-Version: 4.4.0

=== debian/rules ===
--- 
+++ 
@@ -26,11 +26,13 @@
 	dh_auto_install
 	$(MAKE) install-META DESTDIR=$(DESTDIR)
 
-.PHONY: override_dh_install
-override_dh_install:
-	dh_install --fail-missing
+.PHONY: override_dh_missing
+override_dh_missing:
+	dh_missing --fail-missing
 
 # This is necessary because upstream contains a build/ directory
 .PHONY: build
 build:
 	dh $@ --with ocaml
+
+override_dh_dwz:

## camlp4 4.11+1

=== Makefile ===
--- 
+++ 
@@ -10,18 +10,18 @@
 
 .PHONY: byte
 byte:
-	$(OB) `./build/camlp4-byte-only.sh`
+	$(OB) `sh ./build/camlp4-byte-only.sh`
 
 .PHONY: native
 native:
-	$(OB) `./build/camlp4-native-only.sh`
+	$(OB) `sh ./build/camlp4-native-only.sh`
 
 .PHONY: all
 all: byte native
 
 .PHONY: install
 install:
-	env DESTDIR=$(DESTDIR) ./build/install.sh
+	env DESTDIR=$(DESTDIR) sh ./build/install.sh
 
 .PHONY: install-META
 install-META: camlp4/META
@@ -33,11 +33,11 @@
 
 .PHONY: bootstrap
 bootstrap:
-	./build/camlp4-bootstrap.sh
+	sh ./build/camlp4-bootstrap.sh
 
 .PHONY: Camlp4Ast
 Camlp4Ast:
-	./build/camlp4-mkCamlp4Ast.sh
+	sh ./build/camlp4-mkCamlp4Ast.sh
 
 .PHONY: clean
 clean:

=== debian/changelog ===
camlp4 (4.11+1-1) unstable; urgency=medium

  [ Stéphane Glondu ]
  * New upstream release
  * Bump debhelper compat level to 13
  * Add Rules-Requires-Root: no

  [ Debian Janitor ]
  * Set debhelper-compat version in Build-Depends.
  * Update standards version to 4.5.0, no changes needed.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Stéphane Glondu <glondu@debian.org>  Wed, 14 Oct 2020 06:18:56 +0200

=== debian/control ===
--- 
+++ 
@@ -6,11 +6,12 @@
  Stéphane Glondu <glondu@debian.org>,
  Ximin Luo <infinity0@debian.org>
 Build-Depends:
- debhelper (>= 12),
- ocaml-nox (>= 4.08),
+ debhelper-compat (= 13),
+ ocaml-nox (>= 4.11),
  ocamlbuild (>= 0.10.1),
  dh-ocaml
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: https://github.com/ocaml/camlp4
 Vcs-Browser: https://salsa.debian.org/ocaml-team/camlp4
 Vcs-Git: https://salsa.debian.org/ocaml-team/camlp4.git

=== debian/rules ===
--- 
+++ 
@@ -26,13 +26,7 @@
 	dh_auto_install
 	$(MAKE) install-META DESTDIR=$(DESTDIR)
 
-.PHONY: override_dh_missing
-override_dh_missing:
-	dh_missing --fail-missing
-
 # This is necessary because upstream contains a build/ directory
 .PHONY: build
 build:
 	dh $@ --with ocaml
-
-override_dh_dwz:

=== debian/watch ===
version=3
https://github.com/ocaml/camlp4/tags/ .*/([\d\.+]+)\.tar\.gz

## camlp4 4.13%2B1

=== debian/changelog ===
camlp4 (4.13+1-1build1) jammy; urgency=medium

  * No-change rebuild for ocaml abi changes.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 25 Jan 2022 07:07:38 +0100

camlp4 (4.13+1-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.6.0
  * Bump debian/watch version to 4

 -- Stéphane Glondu <glondu@debian.org>  Thu, 20 Jan 2022 06:24:34 +0100

=== debian/watch ===
version=4
https://github.com/ocaml/camlp4/tags/ .*/([\d\.+]+)\.tar\.gz

## camlp4 4.13+1

=== camlp4/unmaintained/etc/Makefile ===


include ../config/Makefile.cnf

INCLUDES=-I ../camlp4 -I ../lib -I ../meta -I $(OTOP)/lex -I $(OTOP)/parsing
OBJS=q_phony.cmo pa_o.cmo pa_op.cmo pa_oop.cmo pa_ru.cmo pa_extfun.cmo pa_fstream.cmo pa_ifdef.cmo pr_r.cmo pr_rp.cmo pr_o.cmo pr_op.cmo pr_extend.cmo pr_extfun.cmo pr_null.cmo pr_depend.cmo genTraversal.cmo fi_exc_tracer.cmo
INTF=pa_o.cmi
CAMLP4OM=pa_o.cmo pa_op.cmo ../meta/pr_dump.cmo
CAMLP4OMX=$(CAMLP4OM:.cmo=.cmx)
EXECUTABLES=camlp4o

include ../config/Makefile.base

all-local: mkcamlp4.sh

pr_rp.cmo: parserify.cmo pr_rp_main.cmo
	$(OCAMLC) parserify.cmo pr_rp_main.cmo -a -o $@

pr_op.cmo: parserify.cmo pr_op_main.cmo
	$(OCAMLC) parserify.cmo pr_op_main.cmo -a -o $@

pr_rp.cmx: parserify.cmx pr_rp_main.cmx
	$(OCAMLOPT) parserify.cmx pr_rp_main.cmx -a -o pr_rp.cmxa
	mv pr_rp.cmxa pr_rp.cmx
	mv pr_rp.$(A) pr_rp.$(O)

pr_op.cmx: parserify.cmx pr_op_main.cmx
	$(OCAMLOPT) parserify.cmx pr_op_main.cmx -a -o pr_op.cmxa
	mv pr_op.cmxa pr_op.cmx
	mv pr_op.$(A) pr_op.$(O)

camlp4o$(EXE): ../camlp4/camlp4$(EXE) $(CAMLP4OM)
	rm -f camlp4o$(EXE)
	cd ../camlp4; $(MAKE) CAMLP4=../etc/camlp4o$(EXE) CAMLP4M="-I ../etc $(CAMLP4OM)"

camlp4o.opt: $(CAMLP4OMX)
	rm -f camlp4o.opt
	cd ../camlp4; $(MAKE) ../etc/camlp4o.opt CAMLP4OPT=../etc/camlp4o.opt CAMLP4M="-I ../etc $(CAMLP4OMX)"

mkcamlp4.sh: mkcamlp4.sh.tpl version.sh
	sed -e "s!LIBDIR!$(LIBDIR)!g" -e "/define VERSION/r version.sh" \
	    mkcamlp4.sh.tpl > mkcamlp4.sh

version.sh : $(OTOP)/VERSION
	echo "VERSION=\"`sed -e 1q ../VERSION`\"" >version.sh

install-local:
	-$(MKDIR) "$(LIBDIR)/camlp4" "$(BINDIR)"
	cp $(OBJS) "$(LIBDIR)/camlp4/."
	cp $(INTF) "$(LIBDIR)/camlp4/."
	cp camlp4o$(EXE) "$(BINDIR)/."
	if test -f camlp4o.opt; then \
	  cp camlp4o.opt "$(BINDIR)/camlp4o.opt$(EXE)"; \
	  cp $(OBJSX) "$(LIBDIR)/camlp4/."; \
	  for file in $(OBJSX); do \
	    cp "`echo $$file | sed -e 's/\.cmx$$/.$(O)/'`" "$(LIBDIR)/camlp4/."; \
	  done ; \
	fi
	cp mkcamlp4.sh "$(BINDIR)/mkcamlp4"
	chmod a+x "$(BINDIR)/mkcamlp4"

include .depend

=== camlp4/unmaintained/lib/Makefile ===


include ../config/Makefile.cnf

INCLUDES=-I $(OTOP)/parsing -I $(OTOP)/utils
LIBRARIES=gramlib.cma
OBJS=$(OTOP)/utils/misc.cmo $(OTOP)/parsing/linenum.cmo		\
     $(OTOP)/utils/warnings.cmo $(OTOP)/parsing/location.cmo	\
     $(OTOP)/utils/config.cmo debug.cmo loc.cmo			\
     token.cmo lexer_token.cmo lexer_error.cmo			\
     plexer.cmo grammar.cmo extfun.cmo				\
     fstream.cmo
CLEANFILES=plexer.ml

include ../config/Makefile.base

debug.cmo: debug.cmi
debug.cmo: debug.ml
	$(OCAMLC) -pp '$(CAMLP4BOOT)' -rectypes $(OCAMLCFLAGS) $< -c -o $@

plexer.cmo: plexer.ml plexer.cmi
	$(OCAMLC) $(OCAMLCFLAGS) $< -c -o $@

plexer.cmx: plexer.ml plexer.cmi
	$(OCAMLOPT) $(OCAMLCFLAGS) $< -c -o $@

$(LIBRARIES): $(OBJS)
	$(OCAMLC) -linkall $(OBJS) -a -o $(LIBRARIES)

$(LIBRARIESX): $(OBJSX)
	$(OCAMLOPT) -linkall $(OBJSX) -a -o $(LIBRARIESX)

$(LIBRARIESP): $(OBJSP)
	$(OCAMLOPT) -linkall $(OBJSP) -a -o $(LIBRARIESP)

install-local:
	-$(MKDIR) "$(LIBDIR)/camlp4"
	cp $(LIBRARIES) *.mli "$(LIBDIR)/camlp4/."
	cp *.cmi "$(LIBDIR)/camlp4/."
	test -f $(LIBRARIESX) && $(MAKE) installopt LIBDIR="$(LIBDIR)" || true

installopt:
	for f in $(LIBRARIESX) $(LIBRARIESP) *.cmx ; do \
		test -f $$f && cp $$f "$(LIBDIR)/camlp4/." || true ; \
	done
	# Special treatment for this one: some versions of make don't like $(A) in $(TARGET:.cma=.$(A))
	target="`echo $(LIBRARIES) | sed -e 's/\.cma$$/.$(A)/'`" ; \
	   if test -f $$target ; then \
	      cp $$target "$(LIBDIR)/camlp4/." && ( cd "$(LIBDIR)/camlp4/." && $(RANLIB) $$target ) \
	  fi

include .depend

=== debian/control ===
--- 
+++ 
@@ -7,10 +7,10 @@
  Ximin Luo <infinity0@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
- ocaml-nox (>= 4.11),
+ ocaml (>= 4.13),
  ocamlbuild (>= 0.10.1),
  dh-ocaml
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://github.com/ocaml/camlp4
 Vcs-Browser: https://salsa.debian.org/ocaml-team/camlp4

## camlp4 4.14+1

=== debian/changelog ===
camlp4 (4.14+1-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.6.2

 -- Stéphane Glondu <glondu@debian.org>  Thu, 21 Sep 2023 01:12:03 +0200

=== debian/control ===
--- 
+++ 
@@ -7,10 +7,10 @@
  Ximin Luo <infinity0@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
- ocaml (>= 4.13),
+ ocaml (>= 4.14),
  ocamlbuild (>= 0.10.1),
  dh-ocaml
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/ocaml/camlp4
 Vcs-Browser: https://salsa.debian.org/ocaml-team/camlp4

## camlp4 5.2+1

=== debian/changelog ===
camlp4 (5.2+1-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Thu, 08 Aug 2024 02:07:40 +0200

=== debian/control ===
--- 
+++ 
@@ -7,8 +7,10 @@
  Ximin Luo <infinity0@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
- ocaml (>= 4.14),
+ ocaml (>= 5.2),
  ocamlbuild (>= 0.10.1),
+ ocaml-findlib,
+ libcamlp-streams-ocaml-dev,
  dh-ocaml
 Standards-Version: 4.6.2
 Rules-Requires-Root: no

## camlp4 5.3+1

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-OB := ocamlbuild -classic-display -no-ocamlfind
+OB := ocamlbuild -classic-display -use-ocamlfind -plugin-tag "package(camlp-streams)"
 DESTDIR=
 
 -include config.sh

=== debian/changelog ===
camlp4 (5.3+1-1build1) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 29 Jan 2025 10:54:52 +0100

camlp4 (5.3+1-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.7.0

 -- Stéphane Glondu <glondu@debian.org>  Mon, 27 Jan 2025 03:31:56 +0100

=== debian/control ===
--- 
+++ 
@@ -7,12 +7,12 @@
  Ximin Luo <infinity0@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
- ocaml (>= 5.2),
+ ocaml (>= 5.3),
  ocamlbuild (>= 0.10.1),
  ocaml-findlib,
  libcamlp-streams-ocaml-dev,
  dh-ocaml
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://github.com/ocaml/camlp4
 Vcs-Browser: https://salsa.debian.org/ocaml-team/camlp4

## camlp4 5.4%2B1

=== debian/changelog ===
camlp4 (5.4+1-1) unstable; urgency=medium

  * New upstream release
  * Switch debian/watch to version 5
  * Bump Standards-Version to 4.7.2
  * Remove Rules-Requires-Root

 -- Stéphane Glondu <glondu@debian.org>  Fri, 26 Dec 2025 19:27:16 +0100

## camlp4 5.4+1

=== debian/changelog ===
camlp4 (5.4+1-1build4) resolute; urgency=medium

  * No change rebuild with fixed amd64v3 builders

 -- Sebastien Bacher <seb128@ubuntu.com>  Thu, 26 Feb 2026 23:06:01 +0100

camlp4 (5.4+1-1build3) resolute; urgency=medium

  * No change rebuild with fixed amd64v3 builders

 -- Sebastien Bacher <seb128@ubuntu.com>  Wed, 25 Feb 2026 15:24:37 +0100

camlp4 (5.4+1-1build2) resolute; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 24 Jan 2026 03:05:54 +0100

camlp4 (5.4+1-1build1) resolute; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 29 Dec 2025 09:52:43 +0100

=== debian/watch ===
Version: 5

Source: https://github.com/ocaml/camlp4/tags/
Matching-Pattern: .*/([\d\.+]+)\.tar\.gz
